Index: kernel/arch/ia64/Makefile.inc
===================================================================
--- kernel/arch/ia64/Makefile.inc	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ kernel/arch/ia64/Makefile.inc	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -73,5 +73,5 @@
 
 ARCH_AUTOGENS_AG = \
-	arch/$(KARCH)/include/arch/istate_struct.ag \
-	arch/$(KARCH)/include/arch/context_struct.ag
+	arch/$(KARCH)/include/arch/istate_struct.ag.h \
+	arch/$(KARCH)/include/arch/context_struct.ag.h
 
Index: kernel/arch/ia64/include/arch/context_struct.h
===================================================================
--- kernel/arch/ia64/include/arch/context_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ kernel/arch/ia64/include/arch/context_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,87 @@
+/* Copyright (c) 2014 Jakub Jermar
+ * All rights preserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#pragma once
+#include <typedefs.h>
+
+// Only save registers that must be preserved across function calls.
+typedef struct context {
+	// Application registers.
+	uint64_t ar_pfs;
+	uint64_t ar_unat_caller;
+	uint64_t ar_unat_callee;
+	uint64_t ar_rsc;
+	// ar_bsp
+	uint64_t bsp;
+	uint64_t ar_rnat;
+	uint64_t ar_lc;
+
+	// General registers.
+	uint64_t r1;
+	uint64_t r4;
+	uint64_t r5;
+	uint64_t r6;
+	uint64_t r7;
+	// r12
+	uint64_t sp;
+	uint64_t r13;
+
+	// Branch registers.
+	// b0
+	uint64_t pc;
+	uint64_t b1;
+	uint64_t b2;
+	uint64_t b3;
+	uint64_t b4;
+	uint64_t b5;
+
+	// Predicate registers.
+	uint64_t pr;
+	uint128_t f2;
+	uint128_t f3;
+	uint128_t f4;
+	uint128_t f5;
+	uint128_t f16;
+	uint128_t f17;
+	uint128_t f18;
+	uint128_t f19;
+	uint128_t f20;
+	uint128_t f21;
+	uint128_t f22;
+	uint128_t f23;
+	uint128_t f24;
+	uint128_t f25;
+	uint128_t f26;
+	uint128_t f27;
+	uint128_t f28;
+	uint128_t f29;
+	uint128_t f30;
+	uint128_t f31;
+
+	ipl_t ipl;
+} context_t;
+
Index: kernel/arch/ia64/include/arch/interrupt.h
===================================================================
--- kernel/arch/ia64/include/arch/interrupt.h	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ kernel/arch/ia64/include/arch/interrupt.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -37,4 +37,5 @@
 
 #ifndef __ASM__
+#include <_bits/native.h>
 #include <arch/istate.h>
 #include <stdint.h>
Index: kernel/arch/ia64/include/arch/istate_struct.h
===================================================================
--- kernel/arch/ia64/include/arch/istate_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ kernel/arch/ia64/include/arch/istate_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,93 @@
+/* Copyright (c) 2014 Jakub Jermar
+ * All rights preserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#pragma once
+#include <stdint.h>
+
+#ifdef KERNEL
+#include <arch/register.h>
+#else
+#include <libarch/register.h>
+#endif
+
+typedef struct istate {
+	uint128_t f2;
+	uint128_t f3;
+	uint128_t f4;
+	uint128_t f5;
+	uint128_t f6;
+	uint128_t f7;
+	uint128_t f8;
+	uint128_t f9;
+	uint128_t f10;
+	uint128_t f11;
+	uint128_t f12;
+	uint128_t f13;
+	uint128_t f14;
+	uint128_t f15;
+	uint128_t f16;
+	uint128_t f17;
+	uint128_t f18;
+	uint128_t f19;
+	uint128_t f20;
+	uint128_t f21;
+	uint128_t f22;
+	uint128_t f23;
+	uint128_t f24;
+	uint128_t f25;
+	uint128_t f26;
+	uint128_t f27;
+	uint128_t f28;
+	uint128_t f29;
+	uint128_t f30;
+	uint128_t f31;
+	uintptr_t ar_bsp;
+	uintptr_t ar_bspstore;
+	uintptr_t ar_bspstore_new;
+	uint64_t ar_rnat;
+	uint64_t ar_ifs;
+	uint64_t ar_pfs;
+	uint64_t ar_rsc;
+	uintptr_t cr_ifa;
+	cr_isr_t cr_isr;
+	uintptr_t cr_iipa;
+	psr_t cr_ipsr;
+	uintptr_t cr_iip;
+	uint64_t pr;
+	uintptr_t sp;
+
+	// The following variables are defined only for break_instruction
+	// handler.
+	uint64_t in0;
+	uint64_t in1;
+	uint64_t in2;
+	uint64_t in3;
+	uint64_t in4;
+	uint64_t in5;
+	uint64_t in6;
+} istate_t;
+
Index: kernel/arch/ia64/src/context.S
===================================================================
--- kernel/arch/ia64/src/context.S	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ kernel/arch/ia64/src/context.S	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -28,5 +28,5 @@
 
 #include <abi/asmtool.h>
-#include <arch/context_struct.h>
+#include <arch/context_struct.ag.h>
 
 .text
Index: kernel/arch/ia64/src/ivt.S
===================================================================
--- kernel/arch/ia64/src/ivt.S	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ kernel/arch/ia64/src/ivt.S	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -33,5 +33,5 @@
 #include <arch/mm/page.h>
 #include <arch/interrupt.h>
-#include <arch/istate_struct.h>
+#include <arch/istate_struct.ag.h>
 #include <align.h>
 
Index: kernel/arch/mips32/Makefile.inc
===================================================================
--- kernel/arch/mips32/Makefile.inc	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ kernel/arch/mips32/Makefile.inc	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -89,5 +89,5 @@
 
 ARCH_AUTOGENS_AG = \
-	arch/$(KARCH)/include/arch/istate_struct.ag \
-	arch/$(KARCH)/include/arch/context_struct.ag \
-	arch/$(KARCH)/include/arch/fpu_context_struct.ag
+	arch/$(KARCH)/include/arch/istate_struct.ag.h \
+	arch/$(KARCH)/include/arch/context_struct.ag.h \
+	arch/$(KARCH)/include/arch/fpu_context_struct.ag.h
Index: kernel/arch/ppc32/Makefile.inc
===================================================================
--- kernel/arch/ppc32/Makefile.inc	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ kernel/arch/ppc32/Makefile.inc	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -60,6 +60,6 @@
 
 ARCH_AUTOGENS_AG = \
-	arch/$(KARCH)/include/arch/istate_struct.ag \
-	arch/$(KARCH)/include/arch/context_struct.ag \
-	arch/$(KARCH)/include/arch/fpu_context_struct.ag
+	arch/$(KARCH)/include/arch/istate_struct.ag.h \
+	arch/$(KARCH)/include/arch/context_struct.ag.h \
+	arch/$(KARCH)/include/arch/fpu_context_struct.ag.h
 
Index: kernel/arch/riscv64/Makefile.inc
===================================================================
--- kernel/arch/riscv64/Makefile.inc	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ kernel/arch/riscv64/Makefile.inc	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -55,4 +55,4 @@
 
 ARCH_AUTOGENS_AG = \
-	arch/$(KARCH)/include/arch/istate_struct.ag \
-	arch/$(KARCH)/include/arch/context_struct.ag
+	arch/$(KARCH)/include/arch/istate_struct.ag.h \
+	arch/$(KARCH)/include/arch/context_struct.ag.h
Index: kernel/arch/sparc64/Makefile.inc
===================================================================
--- kernel/arch/sparc64/Makefile.inc	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ kernel/arch/sparc64/Makefile.inc	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -111,5 +111,5 @@
 
 ARCH_AUTOGENS_AG = \
-	arch/$(KARCH)/include/arch/istate_struct.ag \
-	arch/$(KARCH)/include/arch/context_struct.ag
+	arch/$(KARCH)/include/arch/istate_struct.ag.h \
+	arch/$(KARCH)/include/arch/context_struct.ag.h
 
Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ kernel/genarch/Makefile.inc	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -173,6 +173,6 @@
 	genarch/src/multiboot/multiboot2.c
 GENARCH_AUTOGENS_AG += \
-	genarch/include/genarch/multiboot/multiboot_memmap_struct.ag \
-	genarch/include/genarch/multiboot/multiboot_info_struct.ag
+	genarch/include/genarch/multiboot/multiboot_memmap_struct.ag.h \
+	genarch/include/genarch/multiboot/multiboot_info_struct.ag.h
 endif
 
Index: kernel/genarch/include/genarch/multiboot/multiboot.h
===================================================================
--- kernel/genarch/include/genarch/multiboot/multiboot.h	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ kernel/genarch/include/genarch/multiboot/multiboot.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -36,6 +36,4 @@
 #define KERN_MULTIBOOT_H_
 
-#include <genarch/multiboot/multiboot_memmap_struct.h>
-#include <genarch/multiboot/multiboot_info_struct.h>
 
 #define MULTIBOOT_HEADER_MAGIC  0x1badb002
@@ -52,5 +50,13 @@
 #define MULTIBOOT_INFO_FLAGS_MMAP	0x40
 
-#ifndef __ASM__
+#ifdef __ASM__
+
+#include <genarch/multiboot/multiboot_memmap_struct.ag.h>
+#include <genarch/multiboot/multiboot_info_struct.ag.h>
+
+#else
+
+#include <genarch/multiboot/multiboot_memmap_struct.h>
+#include <genarch/multiboot/multiboot_info_struct.h>
 
 #include <typedefs.h>
Index: kernel/genarch/include/genarch/multiboot/multiboot_info_struct.h
===================================================================
--- kernel/genarch/include/genarch/multiboot/multiboot_info_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ kernel/genarch/include/genarch/multiboot/multiboot_info_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,43 @@
+/* Copyright (c) 2016 Jakub Jermar
+ * All rights preserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#pragma once
+#include <stdint.h>
+
+typedef struct multiboot_info {
+	uint32_t flags;
+	uint32_t mem_lower;
+	uint32_t mem_upper;
+	uint32_t boot_device;
+	uint32_t cmd_line;
+	uint32_t mods_count;
+	uint32_t mods_addr;
+	uint32_t syms[4];
+	uint32_t mmap_length;
+	uint32_t mmap_addr;
+} __attribute__((packed)) multiboot_info_t;
+
Index: kernel/genarch/include/genarch/multiboot/multiboot_memmap_struct.h
===================================================================
--- kernel/genarch/include/genarch/multiboot/multiboot_memmap_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ kernel/genarch/include/genarch/multiboot/multiboot_memmap_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,36 @@
+/* Copyright (c) 2016 Jakub Jermar
+ * All rights preserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#pragma once
+#include <stdint.h>
+#include <arch/boot/memmap_struct.h>
+
+typedef struct multiboot_memmap {
+	uint32_t size;
+	e820memmap_t mm_info;
+} __attribute__((packed)) multiboot_memmap_t;
+
Index: tools/autogen2.awk
===================================================================
--- tools/autogen2.awk	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ tools/autogen2.awk	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,23 @@
+#!/usr/bin/awk -f
+
+/}.*;/ {
+	if (($0 != "};") && ($0 != "} " struct_name "_t;")) {
+		print("Bad struct ending: " $0) > "/dev/stderr"
+		exit 1
+	}
+	print "DEFINE_STRUCT(" struct_name ", " toupper(struct_name) ")"
+	struct_name = ""
+}
+
+/;$/ {
+	if (struct_name != "") {
+		# Remove array subscript, if any.
+		sub("(\\[.*\\])?;", "", $0)
+		member = $NF
+		print "DEFINE_MEMBER(" struct_name ", " toupper(struct_name) ", " member ", " toupper(member) ")"
+	}
+}
+
+/^typedef struct .* \{/ {
+	struct_name = $3
+}
Index: tools/autotool.py
===================================================================
--- tools/autotool.py	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ tools/autotool.py	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -681,6 +681,4 @@
 		sandbox_leave(owd)
 
-	common['AUTOGEN'] = "%s/autogen.py" % os.path.dirname(os.path.abspath(sys.argv[0]))
-
 	create_makefile(MAKEFILE, common)
 	create_header(HEADER, macros)
Index: uspace/Makefile.common
===================================================================
--- uspace/Makefile.common	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ uspace/Makefile.common	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -67,4 +67,6 @@
 CONFIG_MAKEFILE = $(ROOT_PATH)/Makefile.config
 CONFIG_HEADER = $(ROOT_PATH)/config.h
+
+AUTOGEN = $(ROOT_PATH)/tools/autogen2.sh
 
 -include $(VERSION_DEF)
@@ -352,4 +354,7 @@
 	$(CC_JOB) -c -MD -MP $(DEFS) $(LIB_CFLAGS) $(EXTRA_CFLAGS)
 
+%.ag.h %.ag.s %.ag.c %.ag.d: %.h
+	CC="$(CC)" CFLAGS="$(CFLAGS)" $(AUTOGEN) $< $@
+
 -include $(DEPENDS)
 
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ uspace/lib/c/Makefile	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -48,10 +48,9 @@
 -include arch/$(UARCH)/Makefile.inc
 
-ARCH_AUTOGENS_H := $(addsuffix .h,$(basename $(ARCH_AUTOGENS_AG)))
-ARCH_AUTOGENS_PROBE_C := $(addsuffix .ag.probe.c,$(basename $(ARCH_AUTOGENS_AG)))
-ARCH_AUTOGENS_PROBE_S := $(addsuffix .ag.probe.s,$(basename $(ARCH_AUTOGENS_AG)))
-
-PRE_DEPEND += $(ARCH_AUTOGENS_H)
-EXTRA_CLEAN += $(ARCH_AUTOGENS_H) $(ARCH_AUTOGENS_PROBE_C) $(ARCH_AUTOGENS_PROBE_S)
+ARCH_AUTOGENS_PROBE_C := $(ARCH_AUTOGENS_AG:%.ag.h=.ag.c)
+ARCH_AUTOGENS_PROBE_S := $(ARCH_AUTOGENS_AG:%.ag.h=.ag.s)
+
+PRE_DEPEND += $(ARCH_AUTOGENS_AG)
+EXTRA_CLEAN += $(ARCH_AUTOGENS_AG) $(ARCH_AUTOGENS_PROBE_C) $(ARCH_AUTOGENS_PROBE_S)
 
 GENERIC_SOURCES = \
@@ -194,9 +193,4 @@
 include $(USPACE_PREFIX)/Makefile.common
 
-%.h: %.ag
-	$(AUTOGEN) probe $< >$<.probe.c
-	$(CC_AUTOGEN) $(DEFS) $(CFLAGS) -S -o $<.probe.s $<.probe.c
-	$(AUTOGEN) generate $< <$<.probe.s >$@
-
 $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld: $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld.in
 	$(CC) $(DEFS) $(CFLAGS) -DLIBC_PATH=$(CURDIR) -E -x c $< | grep -v "^\#" > $@
Index: uspace/lib/c/arch/amd64/Makefile.inc
===================================================================
--- uspace/lib/c/arch/amd64/Makefile.inc	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ uspace/lib/c/arch/amd64/Makefile.inc	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -37,6 +37,5 @@
 
 ARCH_AUTOGENS_AG = \
-	arch/$(UARCH)/include/libarch/istate_struct.ag \
-	arch/$(UARCH)/include/libarch/fibril_context.ag
+	arch/$(UARCH)/include/libarch/fibril_context.ag.h
 
 EXTRA_OUTPUT += arch/$(UARCH)/src/entry.o
Index: uspace/lib/c/arch/amd64/include/libarch/fibril_context.h
===================================================================
--- uspace/lib/c/arch/amd64/include/libarch/fibril_context.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ uspace/lib/c/arch/amd64/include/libarch/fibril_context.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,45 @@
+/* Copyright (c) 2014 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#pragma once
+#include <stdint.h>
+
+typedef struct context {
+	/* We include only registers that must be preserved
+	 * during function call.
+	 */
+	uint64_t sp;
+	uint64_t pc;
+	uint64_t rbx;
+	uint64_t rbp;
+	uint64_t r12;
+	uint64_t r13;
+	uint64_t r14;
+	uint64_t r15;
+	uint64_t tls;
+} context_t;
+
Index: uspace/lib/c/arch/amd64/include/libarch/istate_struct.h
===================================================================
--- uspace/lib/c/arch/amd64/include/libarch/istate_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ uspace/lib/c/arch/amd64/include/libarch/istate_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,1 @@
+../../../../../../../kernel/arch/amd64/include/arch/istate_struct.h
Index: uspace/lib/c/arch/amd64/src/fibril.S
===================================================================
--- uspace/lib/c/arch/amd64/src/fibril.S	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ uspace/lib/c/arch/amd64/src/fibril.S	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -28,5 +28,5 @@
 
 #include <abi/asmtool.h>
-#include <libarch/fibril_context.h>
+#include <libarch/fibril_context.ag.h>
 
 .text
Index: uspace/lib/c/arch/arm32/Makefile.inc
===================================================================
--- uspace/lib/c/arch/arm32/Makefile.inc	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ uspace/lib/c/arch/arm32/Makefile.inc	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -38,8 +38,4 @@
 	arch/$(UARCH)/src/stacktrace_asm.S
 
-ARCH_AUTOGENS_AG = \
-	arch/$(UARCH)/include/libarch/istate_struct.ag \
-	arch/$(UARCH)/include/libarch/fibril_context.ag
-
 EXTRA_OUTPUT += arch/$(UARCH)/src/entry.o
 
Index: uspace/lib/c/arch/arm32/include/libarch/fibril_context.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/fibril_context.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ uspace/lib/c/arch/arm32/include/libarch/fibril_context.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,24 @@
+#pragma once
+#include <stdint.h>
+
+/*
+ * Only registers preserved accross function calls are included. r9 is
+ * used to store a TLS address. -ffixed-r9 gcc forces gcc not to use this
+ * register. -mtp=soft forces gcc to use #__aeabi_read_tp to obtain
+ * TLS address.
+ */
+typedef struct context {
+	uintptr_t sp;
+	uintptr_t pc;
+	uint32_t r4;
+	uint32_t r5;
+	uint32_t r6;
+	uint32_t r7;
+	uint32_t r8;
+	/* r9*/
+	uint32_t tls;
+	uint32_t r10;
+	/* r11 */
+	uint32_t fp;
+} context_t;
+
Index: uspace/lib/c/arch/arm32/include/libarch/istate_struct.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/istate_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ uspace/lib/c/arch/arm32/include/libarch/istate_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,1 @@
+../../../../../../../kernel/arch/arm32/include/arch/istate_struct.h
Index: uspace/lib/c/arch/ia32/Makefile.inc
===================================================================
--- uspace/lib/c/arch/ia32/Makefile.inc	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ uspace/lib/c/arch/ia32/Makefile.inc	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -39,6 +39,5 @@
 
 ARCH_AUTOGENS_AG = \
-	arch/$(UARCH)/include/libarch/istate_struct.ag \
-	arch/$(UARCH)/include/libarch/fibril_context.ag
+	arch/$(UARCH)/include/libarch/fibril_context.ag.h
 
 EXTRA_OUTPUT += arch/$(UARCH)/src/entry.o
Index: uspace/lib/c/arch/ia32/include/libarch/fibril_context.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/fibril_context.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ uspace/lib/c/arch/ia32/include/libarch/fibril_context.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,41 @@
+/* Copyright (c) 2014 Jakub Jermar
+ * All rights preserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#pragma once
+#include <stdint.h>
+
+/* We include only registers that must be preserved during function call. */
+typedef struct context {
+	uint32_t sp;
+	uint32_t pc;
+	uint32_t ebx;
+	uint32_t esi;
+	uint32_t edi;
+	uint32_t ebp;
+	uint32_t tls;
+} context_t;
+
Index: uspace/lib/c/arch/ia32/include/libarch/istate_struct.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/istate_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ uspace/lib/c/arch/ia32/include/libarch/istate_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,1 @@
+../../../../../../../kernel/arch/ia32/include/arch/istate_struct.h
Index: uspace/lib/c/arch/ia32/src/fibril.S
===================================================================
--- uspace/lib/c/arch/ia32/src/fibril.S	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ uspace/lib/c/arch/ia32/src/fibril.S	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -28,5 +28,5 @@
 
 #include <abi/asmtool.h>
-#include <libarch/fibril_context.h>
+#include <libarch/fibril_context.ag.h>
 
 .text
Index: uspace/lib/c/arch/ia64/Makefile.inc
===================================================================
--- uspace/lib/c/arch/ia64/Makefile.inc	(revision fd57cf17d12bbe3b41626a0b8708f075134a073e)
+++ uspace/lib/c/arch/ia64/Makefile.inc	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -38,6 +38,5 @@
 
 ARCH_AUTOGENS_AG = \
-	arch/$(UARCH)/include/libarch/istate_struct.ag \
-	arch/$(UARCH)/include/libarch/fibril_context.ag
+	arch/$(UARCH)/include/libarch/fibril_context.ag.h
 
 EXTRA_OUTPUT += arch/$(UARCH)/src/entry.o
Index: uspace/lib/c/arch/ia64/include/libarch/fibril_context.h
===================================================================
--- uspace/lib/c/arch/ia64/include/libarch/fibril_context.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ uspace/lib/c/arch/ia64/include/libarch/fibril_context.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,86 @@
+/* Copyright (c) 2014 Jakub Jermar
+ * All rights preserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#pragma once
+#include <stdint.h>
+
+// Only save registers that must be preserved across function calls.
+typedef struct context {
+	// Application registers.
+	uint64_t ar_pfs;
+	uint64_t ar_unat_caller;
+	uint64_t ar_unat_callee;
+	uint64_t ar_rsc;
+	// ar_bsp
+	uint64_t bsp;
+	uint64_t ar_rnat;
+	uint64_t ar_lc;
+
+	// General registers.
+	uint64_t r1;
+	uint64_t r4;
+	uint64_t r5;
+	uint64_t r6;
+	uint64_t r7;
+	// r12
+	uint64_t sp;
+	// r13
+	uint64_t tp;
+
+	// Branch registers.
+	// b0
+	uint64_t pc;
+	uint64_t b1;
+	uint64_t b2;
+	uint64_t b3;
+	uint64_t b4;
+	uint64_t b5;
+
+	// Predicate registers.
+	uint64_t pr;
+	uint128_t f2;
+	uint128_t f3;
+	uint128_t f4;
+	uint128_t f5;
+	uint128_t f16;
+	uint128_t f17;
+	uint128_t f18;
+	uint128_t f19;
+	uint128_t f20;
+	uint128_t f21;
+	uint128_t f22;
+	uint128_t f23;
+	uint128_t f24;
+	uint128_t f25;
+	uint128_t f26;
+	uint128_t f27;
+	uint128_t f28;
+	uint128_t f29;
+	uint128_t f30;
+	uint128_t f31;
+} context_t;
+
Index: uspace/lib/c/arch/ia64/include/libarch/istate_struct.h
===================================================================
--- uspace/lib/c/arch/ia64/include/libarch/istate_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
+++ uspace/lib/c/arch/ia64/include/libarch/istate_struct.h	(revision 0aa06cbe8a6965cc7f1ebfa7236bcd8d5316da16)
@@ -0,0 +1,1 @@
+../../../../../../../kernel/arch/ia64/include/arch/istate_struct.h
